<template>
    <div class="sidebar-mytracker">
        <div class="tracker-title">
            <div class="text">
                <div class="icon"></div>
                <div class="name">My Tracker</div>
                <div v-if="trackerItems.length" class="num">{{ trackerItems.length }}</div>
            </div>
            <span class="clear" @click.prevent="clearItems">Clear</span>
        </div>
        <div class="tracker-content">
            <div v-if="!trackerItems.length && !loading" class="item c-white">No tracked matches</div>
            <horizontal-loader v-if="loading"/>
            <div
                v-if="!loading && trackerItems.length"
                v-for="(item, idx) in trackerItems"
                :key="idx"
                :class="['item', item[0].matchStatus ? `item-${item[0].matchStatus}` : '']"
            >
                <div class="name-line">
                    <div :class="['icon', `icon-football`]"></div>
                    <router-link :to='`/football/match/${item[0].event_id}`' class="name link-to-event">
                        <template v-for="(team, index) in item[0].event.fixture.participants">
                            <strong style="display: block;"
                                    v-if="item[0].event.scoreboard && item[0].event.scoreboard.results && getWinner(item[0].event.scoreboard.results) === index"
                                    :key="index">
                                {{ team.name }}
                            </strong>
                            <div v-else :key="index">
                                {{ team.name }}
                            </div>
                        </template>
                    </router-link>
                    <div class="remove"
                         @click.prevent="removeItem(item[0].event_id, item[0].market_id, item[0].name,(item[0].base_line ? item[0].base_line : null ))"></div>
                </div>
                <div class="numbers">
                    <div v-if="item[0].average" :class="['stats-item', 'co ',betChange(item[0])]">
                        {{ item[0].average.toFixed(2) }}
                    </div>
                    <div class="stats-item x">
                        {{ markets[item[0].market_id].displayName }}
                    </div>
                    <div class="stats-item bet-name">
                        {{ item[0].name }}
                    </div>
                    <div class="stats-item bet-line">
                         {{ item[0].base_line }}
                    </div>
                </div>
                <div v-if="item[0].event" class="score">
                    <div :class="['stats-item', `status-${statusIds[item[0].event.fixture.status_id]}`]"
                         v-if="item[0].event.scoreboard && item[0].event.scoreboard.results">
                        {{ item[0].event.scoreboard.results.split('').join(' ') }}
                    </div>
                    <div class="stats-item stats-item__null d-flex text-center"
                         v-else>
                        <p>- : -</p>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import Api from '../../JokerApi'
import HorizontalLoader from '../HorizontalLoader'
import axios from "axios";
import {mapActions, mapGetters, mapState} from "vuex";

const api = new Api

export default {
    name: 'Tracker',
    components: {HorizontalLoader},
    data() {
        return {
            trackerItems: [],
            loading: true,
            changeAverage:false,
            markets: {
                // key = marketId
                1: {name: '1X2', displayName: '1X2'},
                2: {name: 'Under/Over', displayName: 'O/U'},
                3: {name: 'Asian Handicap', displayName: 'AH'},
                4: {name: 'DNB', displayName: 'DNB'}, /* market id unknown - 4 for example */
                7: {name: 'Double Chance', displayName: 'DC'},
            },
            statusIds: {
                1: 'not_started',
                2: 'in_progress',
                3: 'finished',
                4: 'cancelled',
                5: 'postponed',
                6: 'interrupted',
                7: 'abandoned',
                8: 'coverage_lost',
                9: 'about_to_start'
            },
        }
    },

    methods: {
        ...mapActions(['removeAverage']),
        betChange(item) {
            if (item.average === null) {
                return 'equal'
            }
            let averageCurrent = item.oldAverage
            let old_average = 0;

            if(averageCurrent === undefined){
                old_average = parseFloat(item.average)
            }
            else{
                old_average = parseFloat(item.oldAverage)
            }
            const new_average = parseFloat(item.average)
            if (old_average < new_average) {
                return 'up'
            }
            if (old_average === new_average) {
                return 'equal'
            }
            if (old_average > new_average) {
                return 'down'
            }
        },
        getWinner(score) {
            if (!score) {
                return '-'
            }
            let results = score.split(':');
            let winner;
            if (results[0] > results[1]) {
                winner = 0
            } else if (results[0] < results[1]) {
                winner = 1
            } else {
                winner = 'draw'

            }
            return winner;
        },
        getTrackerId(item){
            return `${item.event_id}_${item.market_id}${item.name}${item.base_line ?? null}`
        },
        clearItems() {
            this.$root.$emit('clearTrackerItems')
        },
        removeItem(event_id, market_id, name,line) {
            this.$root.$emit('removeTrackerItem', {event_id, market_id, name,line})

            this.removeAverage({event_id, market_id, name,line})
        },
    },
    mounted() {
        this.$root.$on('getTrackerItems', (items) => {

            this.trackerItems = Object.values(items)
            this.loading = false
            this.$forceUpdate()
        })
    },
    // destroyed() {
    //     window.Echo.leave(`jokerodds_database_presence-event-bets.${this.id}`)
    // },
    computed: {
        ...mapState(['match']),
    },

}
</script>

<style scoped>
.link-to-event {
    text-decoration: none;
}
</style>
